<template>
  <v-container>
    <v-row>
      <v-col cols="12">
        <blog-list :items="blog" @read="onReadPost" />
      </v-col>
    </v-row>
  </v-container>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import BlogList from '@/components/blog/BlogList.vue';
import { BlogPostResponse } from '@/domain/response/blog/BlogPostResponse';

@Component({
  components: {
    BlogList
  }
})
export default class MainView extends Vue {
  private get blog(): BlogPostResponse {
    return this.$store.getters['blog/items'];
  }

  private async onReadPost(post: BlogPostResponse): Promise<void> {
    await this.$router.push({
      name: 'Post',
      params: {
        path: post.url
      }
    });
  }

  public async mounted(): Promise<void> {
    await this.$store.dispatch('blog/fetch');
  }
}
</script>

<style scoped></style>
